/***********************************************************************************************************************
* File Name    : CCRXmachine.c
* Device(s)    : RX
* H/W Platform : GR-SAKURA (RX63N)
* Description  : CCRX to GNURX converter generated.
***********************************************************************************************************************/

signed long max(signed long data1, signed long data2)
{
	return (data1 > data2)? data1 : data2;
}

signed long min(signed long data1, signed long data2)
{
	return (data1 < data2)? data1 : data2;
}

/*unsigned long revl(unsigned long data)
{
	return __builtin_bswap32(data);
}

unsigned long revw(unsigned long data)
{
	return __builtin_rx_revw(data);
}*/

void xchg(signed long *data1, signed long *data2)
{
	signed long temp = *data1;
	*data1 = *data2;
	*data2 = temp;
}

long long rmpab(long long init, unsigned long count, signed char *addr1, signed char *addr2)
{
	long long result = init;
	unsigned long index;
	for(index = 0; index < count; index++)
	{
		result += addr1[index] * addr2[index];
	}
	return result;
}

long long rmpaw(long long init, unsigned long count, short *addr1, short *addr2)
{
	long long result = init;
	unsigned long index;
	for(index = 0; index < count; index++)
	{
		result += addr1[index] * addr2[index];
	}
	return result;
}

long long rmpal(long long init, unsigned long count, long *addr1, long *addr2)
{
	long long result = init;
	unsigned long index;
	for(index = 0; index < count; index++)
	{
		result += addr1[index] * addr2[index];
	}
	return result;
}

unsigned long rolc(unsigned long data)
{
	__asm("rolc %0":"=r"(data) : "r"(data):); 
	return data;
}

unsigned long rorc(unsigned long data)
{
	__asm("rorc %0":"=r"(data) : "r"(data):);
	return data;
}

unsigned long rotl(unsigned long data, unsigned long num)
{
	__asm("rotl %1, %0":"=r"(data) : "r"(num),"0"(data) :); 
	return data;
}

unsigned long rotr(unsigned long data, unsigned long num)
{
	__asm("rotr %1, %0":"=r"(data) : "r"(num),"0"(data) :); 
	return data;
}

/*void brk(void)
{
	__builtin_rx_brk();
}

#define INTN(N)\
	case N:\
		__builtin_rx_int(N);
		
#define INTN5(N)\
	INTN(N)\
	INTN(N+1)\
	INTN(N+2)\
	INTN(N+3)\
	INTN(N+4)\
	
#define INTN10(N)\
	INTN5(N)\
	INTN5(N+5)\
	
#define INTN50(N)\
	INTN10(N)\
	INTN10(N+10)\
	INTN10(N+20)\
	INTN10(N+30)\
	INTN10(N+40)

void int_exception(signed long num)
{
	switch(num)
	{
	INTN50(0)
	INTN50(50)
	INTN50(100)
	INTN50(150)
	INTN50(200)
	INTN5(250)
	INTN(255)
	default:
		__builtin_rx_int(255);
	}
}

void wait(void)
{
	__builtin_rx_wait();
}

void nop(void)
{
	__asm("nop");
}*/

void set_ipl(signed long level)
{
	unsigned int psw = __builtin_rx_mvfc(0x0);
	psw &= 0xF0FFFFFF;
	psw |= ((level << 24) & 0x0F000000);
	__builtin_rx_mvtc(0x0, psw);
}

unsigned char get_ipl(void)
{
	unsigned int psw = __builtin_rx_mvfc(0x0);
	return (psw & 0x0F000000) >> 24;
}

/*void set_psw(unsigned long data)
{
	__builtin_rx_mvtc (0x0, data);
}

unsigned long get_psw(void)
{
	return __builtin_rx_mvfc(0x0);
}

void set_fpsw(unsigned long data)
{
	__builtin_rx_mvtc(0x3, data);
}

unsigned long get_fpsw(void)
{
	return __builtin_rx_mvfc(0x3);
}

void set_usp(void * data)
{
	__builtin_rx_mvtc(0x2, (int)data);
}

void * get_usp(void)
{
	return (void *)__builtin_rx_mvfc(0x2);
}

void set_isp(void * data)
{
	__builtin_rx_mvtc(0xA, (int)data);
}

void * get_isp(void)
{
	return (void *)__builtin_rx_mvfc(0xA);
}

void set_intb(void * data)
{
	__builtin_rx_mvtc(0xC, (int) data);
}

void * get_intb(void)
{
	return (void *)__builtin_rx_mvfc(0xC);
}

void set_bpsw(unsigned long data)
{
	__builtin_rx_mvtc(0x8, data);
}

unsigned long get_bpsw(void)
{
	return __builtin_rx_mvfc(0x8);
}

void set_bpc(void * data)
{
	__builtin_rx_mvtc(0x9, (int)data);
}

void * get_bpc(void)
{
	return (void *)__builtin_rx_mvfc(0x9);
}

void set_fintv(void * data)
{
	__builtin_rx_mvtc (0xB, (int)data);
}

void * get_fintv(void)
{
	return (void *)__builtin_rx_mvfc(0xB);
}*/

signed long long emul(signed long data1, signed long data2)
{
	return ((signed long long)data1) * ((signed long long)data2);
}

unsigned long long emulu(unsigned long data1, unsigned long data2)
{
	return ((unsigned long long)data1) * ((unsigned long long)data2);
}

void chg_pmusr(void)
{
	__asm("MVFC   PSW,R1" : : :"r1");
    __asm("OR     #00100000h,R1" : : :"r1");
    __asm("PUSH.L R1" : : :"r1");
    __asm("MVFC   PC,R1" : : :"r1");
    __asm("ADD    #10,R1" : : :"r1");
    __asm("PUSH.L R1" : : :"r1");
    __asm("RTE");
}

void set_acc(signed long long data)
{
	__builtin_rx_mvtachi(data >> 32);
	__builtin_rx_mvtaclo(data & 0xFFFFFFFF);
}

signed long long get_acc(void)
{
	signed long long result = ((signed long long)__builtin_rx_mvfachi()) << 32;
	result |= (((signed long long)__builtin_rx_mvfacmi()) << 16) & 0xFFFF0000;
	return result;
}

void setpsw_i(void)
{
	unsigned int psw = __builtin_rx_mvfc(0x0);
	psw |= 0x00010000;
	__builtin_rx_mvtc(0x0, psw);
}

void clrpsw_i(void)
{
	unsigned int psw = __builtin_rx_mvfc(0x0);
	psw &= 0xFFFEFFFF;
	__builtin_rx_mvtc(0x0, psw);
}

long macl(short* data1, short* data2, unsigned long count)
{
	unsigned long index;
	__builtin_rx_mullo(0, 0);
	for(index = 0; index < count; index++)
	{
		__builtin_rx_maclo(data1[index], data2[index]);
		__builtin_rx_machi(data1[index], data2[index]);
	}
	return (long)(get_acc() >> 16);
}

short macw1(short* data1, short* data2, unsigned long count)
{
	unsigned long index;
	__builtin_rx_mullo(0, 0);
	for(index = 0; index < count; index++)
	{
		__builtin_rx_maclo(data1[index], data2[index]);
		__builtin_rx_machi(data1[index], data2[index]);
	}
	__builtin_rx_racw(1);
	return (short)(get_acc() >> 16);
}

short macw2(short* data1, short* data2, unsigned long count)
{
	unsigned long index;
	__builtin_rx_mullo(0, 0);
	for(index = 0; index < count; index++)
	{
		__builtin_rx_maclo(data1[index], data2[index]);
		__builtin_rx_machi(data1[index], data2[index]);
	}
	__builtin_rx_racw(2);
	return (short)(get_acc() >> 16);
}

void _CALL_INIT(void)
{
}
 
void _CALL_END(void)
{
}

void _INITSCT(void)
{
}

