/***********************************************************************************************************************
* File Name    : grsakurarx63n.h
* Device(s)    : RX
* H/W Platform : GR-SAKURA (RX63N)
* Description  : Board specific definitions for the GR-SAKURA.
***********************************************************************************************************************/
/***********************************************************************************************************************
* History : DD.MM.YYYY Version  Description
*         : 10.07.2017 1.00     First Release
***********************************************************************************************************************/

#ifndef GR_SAKURA_RX63N_H
#define GR_SAKURA_RX63N_H

/* Local defines */
#define LED_ON              (1)
#define LED_OFF             (0)
#define SET_BIT_HIGH        (1)
#define SET_BIT_LOW         (0)
#define SET_BYTE_HIGH       (0xFF)
#define SET_BYTE_LOW        (0x00)

/* Switches */
#define SW_ACTIVE           0

#if   BSP_CFG_BOARD_REVISION == 0
    #define SW1                 PORT3.PIDR.BIT.B2
    #define SW1_PDR             PORT3.PDR.BIT.B2
    #define SW1_PMR             PORT3.PMR.BIT.B2
#elif BSP_CFG_BOARD_REVISION == 1
    #define SW1                 PORTA.PIDR.BIT.B7
    #define SW1_PDR             PORTA.PDR.BIT.B7
    #define SW1_PMR             PORTA.PMR.BIT.B7
#else
    #error "Need to define info for this board revision in rskrx63n.h"
#endif

/* LEDs */
#define LED0                PORTA.PODR.BIT.B0
#define LED1                PORTA.PODR.BIT.B1
#define LED2                PORTA.PODR.BIT.B2
#define LED3                PORTA.PODR.BIT.B6
#define LED0_PDR            PORTA.PDR.BIT.B0
#define LED1_PDR            PORTA.PDR.BIT.B1
#define LED2_PDR            PORTA.PDR.BIT.B2
#define LED3_PDR            PORTA.PDR.BIT.B6

/* Slave select. */
#define FLASH_CS            PORT3.PODR.BIT.B1        // SSLB0

#endif /* RSKRX63N_H */

